
SuperStrict

Import "vkOS.bmx"
Import "vkApi.bmx"

Local VulkanLibrary:Byte Ptr
For Local lib:String = EachIn GetVulkanLibraryNames()
	Local DynamicLibrary:Byte Ptr = LoadDynamicLibrary(lib)
	If DynamicLibrary
		VulkanLibrary = DynamicLibrary
		Exit
	EndIf
Next

' Get the only mandatory exported function
If VulkanLibrary
	vkGetInstanceProcAddr = GetDynamicLibraryFuncAddr( VulkanLibrary,"vkGetInstanceProcAddr" )

	If vkGetInstanceProcAddr LoadVulkanGlobalFunctions()
EndIf

Function LoadVulkanGlobalFunctions()
	vkCreateInstance = vkGetInstanceProcAddr(Null,"vkCreateInstance")
	vkEnumerateInstanceExtensionProperties = vkGetInstanceProcAddr(Null,"vkEnumerateInstanceExtensionProperties")
	vkEnumerateInstanceLayerProperties = vkGetInstanceProcAddr(Null,"vkEnumerateInstanceLayerProperties")
EndFunction

Function LoadVulkanInstanceFunctions(instance:Byte Ptr)
	vkDestroyInstance = vkGetInstanceProcAddr(instance,"vkDestroyInstance")
	vkEnumeratePhysicalDevices = vkGetInstanceProcAddr(instance,"vkEnumeratePhysicalDevices")
	vkDestroySurfaceKHR = vkGetInstanceProcAddr(instance,"vkDestroySurfaceKHR")
	vkCreateDisplayPlaneSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateDisplayPlaneSurfaceKHR")
	vkCreateXlibSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateXlibSurfaceKHR")
	vkCreateXcbSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateXcbSurfaceKHR")
	vkCreateWaylandSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateWaylandSurfaceKHR")
	vkCreateMirSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateMirSurfaceKHR")
	vkCreateAndroidSurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateAndroidSurfaceKHR")
	vkCreateWin32SurfaceKHR = vkGetInstanceProcAddr(instance,"vkCreateWin32SurfaceKHR")
	vkCreateDebugReportCallbackEXT = vkGetInstanceProcAddr(instance,"vkCreateDebugReportCallbackEXT")
	vkDestroyDebugReportCallbackEXT = vkGetInstanceProcAddr(instance,"vkDestroyDebugReportCallbackEXT")
	vkDebugReportMessageEXT = vkGetInstanceProcAddr(instance,"vkDebugReportMessageEXT")
	vkGetPhysicalDeviceFeatures = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceFeatures")
	vkGetPhysicalDeviceFormatProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceFormatProperties")
	vkGetPhysicalDeviceImageFormatProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceImageFormatProperties")
	vkGetPhysicalDeviceProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceProperties")
	vkGetPhysicalDeviceQueueFamilyProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceQueueFamilyProperties")
	vkGetPhysicalDeviceMemoryProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceMemoryProperties")
	vkCreateDevice = vkGetInstanceProcAddr(instance,"vkCreateDevice")
	vkEnumerateDeviceExtensionProperties = vkGetInstanceProcAddr(instance,"vkEnumerateDeviceExtensionProperties")
	vkEnumerateDeviceLayerProperties = vkGetInstanceProcAddr(instance,"vkEnumerateDeviceLayerProperties")
	vkGetPhysicalDeviceSparseImageFormatProperties = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceSparseImageFormatProperties")
	vkGetPhysicalDeviceSurfaceSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceSurfaceSupportKHR")
	vkGetPhysicalDeviceSurfaceCapabilitiesKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceSurfaceCapabilitiesKHR")
	vkGetPhysicalDeviceSurfaceFormatsKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceSurfaceFormatsKHR")
	vkGetPhysicalDeviceSurfacePresentModesKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceSurfacePresentModesKHR")
	vkGetPhysicalDeviceDisplayPropertiesKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceDisplayPropertiesKHR")
	vkGetPhysicalDeviceDisplayPlanePropertiesKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceDisplayPlanePropertiesKHR")
	vkGetDisplayPlaneSupportedDisplaysKHR = vkGetInstanceProcAddr(instance,"vkGetDisplayPlaneSupportedDisplaysKHR")
	vkGetDisplayModePropertiesKHR = vkGetInstanceProcAddr(instance,"vkGetDisplayModePropertiesKHR")
	vkCreateDisplayModeKHR = vkGetInstanceProcAddr(instance,"vkCreateDisplayModeKHR")
	vkGetDisplayPlaneCapabilitiesKHR = vkGetInstanceProcAddr(instance,"vkGetDisplayPlaneCapabilitiesKHR")
	vkGetPhysicalDeviceXlibPresentationSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceXlibPresentationSupportKHR")
	vkGetPhysicalDeviceXcbPresentationSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceXcbPresentationSupportKHR")
	vkGetPhysicalDeviceWaylandPresentationSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceWaylandPresentationSupportKHR")
	vkGetPhysicalDeviceMirPresentationSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceMirPresentationSupportKHR")
	vkGetPhysicalDeviceWin32PresentationSupportKHR = vkGetInstanceProcAddr(instance,"vkGetPhysicalDeviceWin32PresentationSupportKHR")
	vkGetDeviceProcAddr = vkGetInstanceProcAddr(instance,"vkGetDeviceProcAddr")
EndFunction

Function LoadVulkanDeviceFunctions(device:Byte Ptr)
	vkDestroyDevice = vkGetDeviceProcAddr(device,"vkDestroyDevice")
	vkGetDeviceQueue = vkGetDeviceProcAddr(device,"vkGetDeviceQueue")
	vkDeviceWaitIdle = vkGetDeviceProcAddr(device,"vkDeviceWaitIdle")
	vkAllocateMemory = vkGetDeviceProcAddr(device,"vkAllocateMemory")
	vkFreeMemory = vkGetDeviceProcAddr(device,"vkFreeMemory")
	vkMapMemory = vkGetDeviceProcAddr(device,"vkMapMemory")
	vkUnmapMemory = vkGetDeviceProcAddr(device,"vkUnmapMemory")
	vkFlushMappedMemoryRanges = vkGetDeviceProcAddr(device,"vkFlushMappedMemoryRanges")
	vkInvalidateMappedMemoryRanges = vkGetDeviceProcAddr(device,"vkInvalidateMappedMemoryRanges")
	vkGetDeviceMemoryCommitment = vkGetDeviceProcAddr(device,"vkGetDeviceMemoryCommitment")
	vkBindBufferMemory = vkGetDeviceProcAddr(device,"vkBindBufferMemory")
	vkBindImageMemory = vkGetDeviceProcAddr(device,"vkBindImageMemory")
	vkGetBufferMemoryRequirements = vkGetDeviceProcAddr(device,"vkGetBufferMemoryRequirements")
	vkGetImageMemoryRequirements = vkGetDeviceProcAddr(device,"vkGetImageMemoryRequirements")
	vkGetImageSparseMemoryRequirements = vkGetDeviceProcAddr(device,"vkGetImageSparseMemoryRequirements")
	vkCreateFence = vkGetDeviceProcAddr(device,"vkCreateFence")
	vkDestroyFence = vkGetDeviceProcAddr(device,"vkDestroyFence")
	vkResetFences = vkGetDeviceProcAddr(device,"vkResetFences")
	vkGetFenceStatus = vkGetDeviceProcAddr(device,"vkGetFenceStatus")
	vkWaitForFences = vkGetDeviceProcAddr(device,"vkWaitForFences")
	vkCreateSemaphore = vkGetDeviceProcAddr(device,"vkCreateSemaphore")
	vkDestroySemaphore = vkGetDeviceProcAddr(device,"vkDestroySemaphore")
	vkCreateEvent = vkGetDeviceProcAddr(device,"vkCreateEvent")
	vkDestroyEvent = vkGetDeviceProcAddr(device,"vkDestroyEvent")
	vkGetEventStatus = vkGetDeviceProcAddr(device,"vkGetEventStatus")
	vkSetEvent = vkGetDeviceProcAddr(device,"vkSetEvent")
	vkResetEvent = vkGetDeviceProcAddr(device,"vkResetEvent")
	vkCreateQueryPool = vkGetDeviceProcAddr(device,"vkCreateQueryPool")
	vkDestroyQueryPool = vkGetDeviceProcAddr(device,"vkDestroyQueryPool")
	vkGetQueryPoolResults = vkGetDeviceProcAddr(device,"vkGetQueryPoolResults")
	vkCreateBuffer = vkGetDeviceProcAddr(device,"vkCreateBuffer")
	vkDestroyBuffer = vkGetDeviceProcAddr(device,"vkDestroyBuffer")
	vkCreateBufferView = vkGetDeviceProcAddr(device,"vkCreateBufferView")
	vkDestroyBufferView = vkGetDeviceProcAddr(device,"vkDestroyBufferView")
	vkCreateImage = vkGetDeviceProcAddr(device,"vkCreateImage")
	vkDestroyImage = vkGetDeviceProcAddr(device,"vkDestroyImage")
	vkGetImageSubresourceLayout = vkGetDeviceProcAddr(device,"vkGetImageSubresourceLayout")
	vkCreateImageView = vkGetDeviceProcAddr(device,"vkCreateImageView")
	vkDestroyImageView = vkGetDeviceProcAddr(device,"vkDestroyImageView")
	vkCreateShaderModule = vkGetDeviceProcAddr(device,"vkCreateShaderModule")
	vkDestroyShaderModule = vkGetDeviceProcAddr(device,"vkDestroyShaderModule")
	vkCreatePipelineCache = vkGetDeviceProcAddr(device,"vkCreatePipelineCache")
	vkDestroyPipelineCache = vkGetDeviceProcAddr(device,"vkDestroyPipelineCache")
	vkGetPipelineCacheData = vkGetDeviceProcAddr(device,"vkGetPipelineCacheData")
	vkMergePipelineCaches = vkGetDeviceProcAddr(device,"vkMergePipelineCaches")
	vkCreateGraphicsPipelines = vkGetDeviceProcAddr(device,"vkCreateGraphicsPipelines")
	vkCreateComputePipelines = vkGetDeviceProcAddr(device,"vkCreateComputePipelines")
	vkDestroyPipeline = vkGetDeviceProcAddr(device,"vkDestroyPipeline")
	vkCreatePipelineLayout = vkGetDeviceProcAddr(device,"vkCreatePipelineLayout")
	vkDestroyPipelineLayout = vkGetDeviceProcAddr(device,"vkDestroyPipelineLayout")
	vkCreateSampler = vkGetDeviceProcAddr(device,"vkCreateSampler")
	vkDestroySampler = vkGetDeviceProcAddr(device,"vkDestroySampler")
	vkCreateDescriptorSetLayout = vkGetDeviceProcAddr(device,"vkCreateDescriptorSetLayout")
	vkDestroyDescriptorSetLayout = vkGetDeviceProcAddr(device,"vkDestroyDescriptorSetLayout")
	vkCreateDescriptorPool = vkGetDeviceProcAddr(device,"vkCreateDescriptorPool")
	vkDestroyDescriptorPool = vkGetDeviceProcAddr(device,"vkDestroyDescriptorPool")
	vkResetDescriptorPool = vkGetDeviceProcAddr(device,"vkResetDescriptorPool")
	vkAllocateDescriptorSets = vkGetDeviceProcAddr(device,"vkAllocateDescriptorSets")
	vkFreeDescriptorSets = vkGetDeviceProcAddr(device,"vkFreeDescriptorSets")
	vkUpdateDescriptorSets = vkGetDeviceProcAddr(device,"vkUpdateDescriptorSets")
	vkCreateFramebuffer = vkGetDeviceProcAddr(device,"vkCreateFramebuffer")
	vkDestroyFramebuffer = vkGetDeviceProcAddr(device,"vkDestroyFramebuffer")
	vkCreateRenderPass = vkGetDeviceProcAddr(device,"vkCreateRenderPass")
	vkDestroyRenderPass = vkGetDeviceProcAddr(device,"vkDestroyRenderPass")
	vkGetRenderAreaGranularity = vkGetDeviceProcAddr(device,"vkGetRenderAreaGranularity")
	vkCreateCommandPool = vkGetDeviceProcAddr(device,"vkCreateCommandPool")
	vkDestroyCommandPool = vkGetDeviceProcAddr(device,"vkDestroyCommandPool")
	vkResetCommandPool = vkGetDeviceProcAddr(device,"vkResetCommandPool")
	vkAllocateCommandBuffers = vkGetDeviceProcAddr(device,"vkAllocateCommandBuffers")
	vkFreeCommandBuffers = vkGetDeviceProcAddr(device,"vkFreeCommandBuffers")
	vkCreateSwapchainKHR = vkGetDeviceProcAddr(device,"vkCreateSwapchainKHR")
	vkDestroySwapchainKHR = vkGetDeviceProcAddr(device,"vkDestroySwapchainKHR")
	vkGetSwapchainImagesKHR = vkGetDeviceProcAddr(device,"vkGetSwapchainImagesKHR")
	vkAcquireNextImageKHR = vkGetDeviceProcAddr(device,"vkAcquireNextImageKHR")
	vkCreateSharedSwapchainsKHR = vkGetDeviceProcAddr(device,"vkCreateSharedSwapchainsKHR")
	vkDebugMarkerSetObjectTagEXT = vkGetDeviceProcAddr(device,"vkDebugMarkerSetObjectTagEXT")
	vkDebugMarkerSetObjectNameEXT = vkGetDeviceProcAddr(device,"vkDebugMarkerSetObjectNameEXT")
	vkBeginCommandBuffer = vkGetDeviceProcAddr(device,"vkBeginCommandBuffer")
	vkEndCommandBuffer = vkGetDeviceProcAddr(device,"vkEndCommandBuffer")
	vkResetCommandBuffer = vkGetDeviceProcAddr(device,"vkResetCommandBuffer")
	vkCmdBindPipeline = vkGetDeviceProcAddr(device,"vkCmdBindPipeline")
	vkCmdSetViewport = vkGetDeviceProcAddr(device,"vkCmdSetViewport")
	vkCmdSetScissor = vkGetDeviceProcAddr(device,"vkCmdSetScissor")
	vkCmdSetLineWidth = vkGetDeviceProcAddr(device,"vkCmdSetLineWidth")
	vkCmdSetDepthBias = vkGetDeviceProcAddr(device,"vkCmdSetDepthBias")
	vkCmdSetBlendConstants = vkGetDeviceProcAddr(device,"vkCmdSetBlendConstants")
	vkCmdSetDepthBounds = vkGetDeviceProcAddr(device,"vkCmdSetDepthBounds")
	vkCmdSetStencilCompareMask = vkGetDeviceProcAddr(device,"vkCmdSetStencilCompareMask")
	vkCmdSetStencilWriteMask = vkGetDeviceProcAddr(device,"vkCmdSetStencilWriteMask")
	vkCmdSetStencilReference = vkGetDeviceProcAddr(device,"vkCmdSetStencilReference")
	vkCmdBindDescriptorSets = vkGetDeviceProcAddr(device,"vkCmdBindDescriptorSets")
	vkCmdBindIndexBuffer = vkGetDeviceProcAddr(device,"vkCmdBindIndexBuffer")
	vkCmdBindVertexBuffers = vkGetDeviceProcAddr(device,"vkCmdBindVertexBuffers")
	vkCmdDraw = vkGetDeviceProcAddr(device,"vkCmdDraw")
	vkCmdDrawIndexed = vkGetDeviceProcAddr(device,"vkCmdDrawIndexed")
	vkCmdDrawIndirect = vkGetDeviceProcAddr(device,"vkCmdDrawIndirect")
	vkCmdDrawIndexedIndirect = vkGetDeviceProcAddr(device,"vkCmdDrawIndexedIndirect")
	vkCmdDispatch = vkGetDeviceProcAddr(device,"vkCmdDispatch")
	vkCmdDispatchIndirect = vkGetDeviceProcAddr(device,"vkCmdDispatchIndirect")
	vkCmdCopyBuffer = vkGetDeviceProcAddr(device,"vkCmdCopyBuffer")
	vkCmdCopyImage = vkGetDeviceProcAddr(device,"vkCmdCopyImage")
	vkCmdBlitImage = vkGetDeviceProcAddr(device,"vkCmdBlitImage")
	vkCmdCopyBufferToImage = vkGetDeviceProcAddr(device,"vkCmdCopyBufferToImage")
	vkCmdCopyImageToBuffer = vkGetDeviceProcAddr(device,"vkCmdCopyImageToBuffer")
	vkCmdUpdateBuffer = vkGetDeviceProcAddr(device,"vkCmdUpdateBuffer")
	vkCmdFillBuffer = vkGetDeviceProcAddr(device,"vkCmdFillBuffer")
	vkCmdClearColorImage = vkGetDeviceProcAddr(device,"vkCmdClearColorImage")
	vkCmdClearDepthStencilImage = vkGetDeviceProcAddr(device,"vkCmdClearDepthStencilImage")
	vkCmdClearAttachments = vkGetDeviceProcAddr(device,"vkCmdClearAttachments")
	vkCmdResolveImage = vkGetDeviceProcAddr(device,"vkCmdResolveImage")
	vkCmdSetEvent = vkGetDeviceProcAddr(device,"vkCmdSetEvent")
	vkCmdResetEvent = vkGetDeviceProcAddr(device,"vkCmdResetEvent")
	vkCmdWaitEvents = vkGetDeviceProcAddr(device,"vkCmdWaitEvents")
	vkCmdPipelineBarrier = vkGetDeviceProcAddr(device,"vkCmdPipelineBarrier")
	vkCmdBeginQuery = vkGetDeviceProcAddr(device,"vkCmdBeginQuery")
	vkCmdEndQuery = vkGetDeviceProcAddr(device,"vkCmdEndQuery")
	vkCmdResetQueryPool = vkGetDeviceProcAddr(device,"vkCmdResetQueryPool")
	vkCmdWriteTimestamp = vkGetDeviceProcAddr(device,"vkCmdWriteTimestamp")
	vkCmdCopyQueryPoolResults = vkGetDeviceProcAddr(device,"vkCmdCopyQueryPoolResults")
	vkCmdPushConstants = vkGetDeviceProcAddr(device,"vkCmdPushConstants")
	vkCmdBeginRenderPass = vkGetDeviceProcAddr(device,"vkCmdBeginRenderPass")
	vkCmdNextSubpass = vkGetDeviceProcAddr(device,"vkCmdNextSubpass")
	vkCmdEndRenderPass = vkGetDeviceProcAddr(device,"vkCmdEndRenderPass")
	vkCmdExecuteCommands = vkGetDeviceProcAddr(device,"vkCmdExecuteCommands")
	vkCmdDebugMarkerBeginEXT = vkGetDeviceProcAddr(device,"vkCmdDebugMarkerBeginEXT")
	vkCmdDebugMarkerEndEXT = vkGetDeviceProcAddr(device,"vkCmdDebugMarkerEndEXT")
	vkCmdDebugMarkerInsertEXT = vkGetDeviceProcAddr(device,"vkCmdDebugMarkerInsertEXT")
	vkQueueSubmit = vkGetDeviceProcAddr(device,"vkQueueSubmit")
	vkQueueWaitIdle = vkGetDeviceProcAddr(device,"vkQueueWaitIdle")
	vkQueueBindSparse = vkGetDeviceProcAddr(device,"vkQueueBindSparse")
	vkQueuePresentKHR = vkGetDeviceProcAddr(device,"vkQueuePresentKHR")
EndFunction

